function v_diff = derive_flot( sigma, v, diff )

    nx = size(v, 2);
    ny = size(v, 1);

    G = @(x,s) ( 1 / (s*sqrt( 2*pi )) ) * exp( - x.^2 / (2*s^2));
    dG = @(x,s) ( - x / (s^3*sqrt( 2*pi )) ) .* exp( - x.^2 / (2*s^2));
    d2G = @(x,s) ( ( (x/s).^2 - 1 ) / ( s^3 * sqrt(2*pi) ) ) ...
                                                    .* exp( - x.^2 / (2*s^2));

    Kx = @(f,s) arrayfun( @(x)f(x,s), -(nx-1)/2:(nx-1)/2 );
    Ky = @(f,s) arrayfun( @(x)f(x,s), -(ny-1)/2:(ny-1)/2 );

    if diff(1) == 0 % Par rapport à X
        v = imfilter(v, Kx(G,sigma), 'circular', 'conv');
    elseif diff(1) == 1    
        v = imfilter(v, Kx(dG,sigma), 'circular', 'conv');
    else
        v = imfilter(v, Kx(d2G,sigma), 'circular', 'conv');
    end                    

    if diff(2) == 0 % Par rapport à Y
        v_diff = imfilter(v, Ky(G,sigma)', 'circular', 'conv');
    elseif diff(2) == 1   
        v_diff = imfilter(v, Ky(dG,sigma)', 'circular', 'conv');
    else  
        v_diff = imfilter(v, Ky(d2G,sigma)', 'circular', 'conv');
    end

end