function [energy_m] = get_flow_local_energy(vx, vy, sift1, sift2, siftpara)
% [u,v] vector field from im1 to im2
% sifti a dense sift repr. of ith image
assert(isequal(size(vx), size(vy)));
assert(isequal(size(sift1), size(sift2)));

A = siftpara.alpha;
D = siftpara.d;
G = siftpara.gamma; % louche, mais what else ?

[H, W] = size(vx); % heigth, width of the image minus ~5 px

energy_m = zeros([H,W, 3]);


% [ii, jj] = meshgrid(1:h, 1:w);
% i_ind = ii + v; % doute sur ces deux lignes
% j_ind = jj + u;
% indices = sub2ind(size(u), i_ind, j_ind);
% diff_sift = sift1 - sift2();
for i = 1:H
    for j= 1:W
        try
        foo = sift1(i,j, :) - sift2(i + vy(i, j), j + vx(i, j), :);
        foo = permute(foo, [2 3 1]);
        catch
            %fprintf('Flow points out of range : %d, %d, %d, %d\n', i, j, vy(i, j), vx(i, j));
            foo = [];
        end;
        energy_m(i,j,1) = norm(foo, 1);
        energy_m(i,j,2) = (vx(i, j)^2 + vy(i, j)^2) * G;
        energy_m(i,j,3) = energy3(i,j);
    end;    
end;


    function r = energy3(i, j)
        r = 0;
        if isequal(i, 1)
            vois_y = [1];
        elseif isequal(i, H)
            vois_y = [-1];
        else 
            vois_y = [-1, 1];
        end;
        
        if isequal(j, 1)
            vois_x = [1];
        elseif isequal(j, W)
            vois_x = [-1];
        else 
            vois_x = [-1, 1];
        end;
        
        for eps_i = vois_y
            r = min(A * abs(vx(i + eps_i, j) - vx(i, j)), D) + min(A * abs(vy(i + eps_i, j) - vy(i, j)), D);
        end;        
        for eps_j = vois_x
            r = min(A * abs(vx(i, j + eps_j) - vx(i, j)), D) + min(A * abs(vy(i, j + eps_j) - vy(i, j)), D);
        end;
    end
end